

import java.awt.Rectangle;

import java.awt.Color;

import java.awt.Font;

import java.awt.FontMetrics;

import java.awt.Image;

import java.awt.Graphics;

import java.awt.Toolkit;

import java.applet.Applet;



class RolloverRegion

	{

	private String label;

	private Font font;

	private Color color;

	private Rectangle bounds;



	private Image popupImage;

	private int popupWidth, popupHeight;



	//////////////////////////////////////////////////////////////////////////

	public RolloverRegion(String label, Font font, Color color,

								Rectangle bounds, Applet parent)

		{

		this.label = label;

		this.color = color;

		this.font = font;

		this.bounds = bounds;

		buildPopupImage(parent);

		}



	//////////////////////////////////////////////////////////////////////////

	private void buildPopupImage(Applet applet)

		{

		//create the popup image a little bigger than the label

		FontMetrics fontMetrics =

			Toolkit.getDefaultToolkit().getFontMetrics(font);

		popupWidth = fontMetrics.stringWidth(label) + 2 * 4;

		int fontHeight = fontMetrics.getHeight();

		popupHeight = fontHeight + 8;

		popupImage = applet.createImage(popupWidth, popupHeight);



		//color the popup image and border it in black

		Graphics graphicsContext = popupImage.getGraphics();

		graphicsContext.setColor(Color.black);

		graphicsContext.fillRect(0, 0, popupWidth, popupHeight);

		graphicsContext.setColor(color);

		graphicsContext.fillRect(1, 1, popupWidth - 2, popupHeight - 2);



		//center the label and draw it into the popup image

		graphicsContext.setColor(Color.black);

		int x = (popupWidth - fontMetrics.stringWidth(label)) / 2;

		int y = (popupHeight - fontHeight) / 2;

		graphicsContext.drawString(label, x, fontHeight + 4);

		}



	//////////////////////////////////////////////////////////////////////////

	public void paint(Graphics graphicsContext)

		{

		//draw a colored rectangle with a 2-pixel black border

		graphicsContext.setColor(Color.black);

		graphicsContext.fillRect(bounds.x, bounds.y, bounds.width, bounds.height);

		graphicsContext.setColor(color);

		graphicsContext.fillRect(bounds.x + 2, bounds.y + 2,

			bounds.width - 4, bounds.height - 4);

		}



	//////////////////////////////////////////////////////////////////////////

	public Image getPopupImage()

		{

		return popupImage;

		}



	//////////////////////////////////////////////////////////////////////////

	public int getPopupHeight()

		{

		return popupHeight;

		}



	//////////////////////////////////////////////////////////////////////////

	public int getPopupWidth()

		{

		return popupWidth;

		}



	//////////////////////////////////////////////////////////////////////////

	public boolean contains(int x, int y)

		{

		return bounds.contains(x, y);

		}

	}

